import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import CheckIcon from "@mui/icons-material/Check";
import TrashIcon from "@mui/icons-material/Delete";
import LockIcon from "@mui/icons-material/Lock";
import WarningAmberIcon from "@mui/icons-material/WarningAmber";
import { Button,
// createTheme,
IconButton,
// makeStyles,
Paper } from "@mui/material";
import { makeStyles } from "@mui/styles";
import isEqual from "lodash/isEqual";
import PreventScrollToParents from "../PreventScrollToParents";
// import { ThemeProvider } from "@mui/styles"

import { createTheme, ThemeProvider } from "@mui/material/styles";
import classnames from "classnames";
import React, { useMemo, useState } from "react";
import CreatableSelect from "react-select/creatable";
import { asMutable } from "seamless-immutable";
import colors from "../colors";
import ErrorMessage from "../Components/ErrorMessage";
import { customStyles } from "../Components/utils";
import TaskFormLabel from "../OCR/TaskFormLabel";
import styles from "../RegionLabel/styles";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
function BrushPopup(_ref) {
  var top = _ref.top,
    left = _ref.left,
    showTags = _ref.showTags,
    lines = _ref.lines,
    lazyBrushClassification = _ref.lazyBrushClassification,
    lazyBrushTags = _ref.lazyBrushTags,
    setLines = _ref.setLines,
    scale = _ref.scale,
    invalid_show = _ref.invalid_show,
    delete_annotation = _ref.delete_annotation,
    setdelete_annotation = _ref.setdelete_annotation,
    annotationType = _ref.annotationType,
    videoTime = _ref.videoTime,
    mouseEvents = _ref.mouseEvents,
    isReadingMode = _ref.isReadingMode,
    setTegged = _ref.setTegged,
    setLoacal_id = _ref.setLoacal_id,
    handleMouseUp = _ref.handleMouseUp,
    convertHextoRgb = _ref.convertHextoRgb,
    setbrushHighlight = _ref.setbrushHighlight,
    onRegionClassAdded = _ref.onRegionClassAdded,
    onRegionTagAdded = _ref.onRegionTagAdded,
    onSelectCls = _ref.onSelectCls,
    regionClassificationLabel = _ref.regionClassificationLabel,
    regionTagsLabel = _ref.regionTagsLabel,
    setBrushOpen = _ref.setBrushOpen,
    isTL = _ref.isTL;
  var getRandomId = function getRandomId() {
    return Math.random().toString().split(".")[1];
  };
  var classes = useStyles();
  var _useState = useState(-1),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    brushValidate = _useState4[0],
    setBrushValidate = _useState4[1];
  window.brushHighlighted = function (value) {
    setOpen(value);
  };
  var popUpPos = function popUpPos(_ref2) {
    var index = _ref2.index,
      top = _ref2.top;
    var labelBoxHeight = open === index ? 170 : 60;
    // console.log(pbox.y, labelBoxHeight)
    var displayOnTop = top > labelBoxHeight;
    return displayOnTop;
  };
  var classification_brush = useMemo(function () {
    return asMutable(lazyBrushClassification);
  }, [lazyBrushClassification.length]);
  var tag_brush = useMemo(function () {
    return asMutable(lazyBrushTags);
  }, [lazyBrushTags.length]);
  var tag_qual_check = function tag_qual_check(tagList, index) {
    var _ref3, _ref4, _lines$index;
    return isEqual((_ref3 = tagList || []) === null || _ref3 === void 0 ? void 0 : _ref3.sort(), (_ref4 = ((_lines$index = lines[index]) === null || _lines$index === void 0 ? void 0 : _lines$index.invalid_tag) || []) === null || _ref4 === void 0 ? void 0 : _ref4.sort());
  };
  var handleChangeClassification = function handleChangeClassification(actionMeta, item, o) {
    var classification = _toConsumableArray(lazyBrushClassification);
    if (actionMeta.action === "create-option") {
      onRegionClassAdded(o.value);
      classification = [].concat(_toConsumableArray(lazyBrushClassification), [o.value]);
    }
    // onSelectCls(o)
    var linessave = _toConsumableArray(lines);
    var find_same_id = linessave === null || linessave === void 0 ? void 0 : linessave.map(function (items, itemIndex) {
      if (items.id === item.id) {
        var _classification;
        lines[itemIndex].popUp.classification = o;
        lines[itemIndex].color = "rgba(".concat(convertHextoRgb(colors[((_classification = classification) === null || _classification === void 0 ? void 0 : _classification.findIndex(function (dropdown) {
          return dropdown.value === o.value;
        })) % colors.length] || "#FF0000"), ",0.5)");
        if (o) {
          lines[itemIndex].update_user = lines[itemIndex].popUp.classification === o ? false : lines[itemIndex].invalid && !invalid_show ? true : false;
        }
      }
      return linessave;
    });
    setLines(linessave);
  };
  var regionClsMandatory = (regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.mandatory) === "mandatory";
  var regionTagsMandatory = (regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.mandatory) === "mandatory";
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement("div", {
    onMouseUp: function onMouseUp() {
      return handleMouseUp();
    }
  }, showTags && (lines === null || lines === void 0 ? void 0 : lines.map(function (item, index) {
    var _lines$index$popUp$cl, _lines$index$popUp$cl2, _lines$index2, _lines$index2$invalid, _item$popUp2, _item$popUp2$classifi, _item$color, _item$popUp3, _asMutable, _item$popUp4;
    return item.isPopupShow === true && item.tool === "pen" && !item.isHide && /*#__PURE__*/React.createElement("div", {
      key: "Brush" + index,
      style: {
        left: "".concat(item.points[0] * scale, "px"),
        top: "".concat(item.points[1] * scale, "px"),
        position: "absolute",
        width: "200px",
        opacity: 1
      },
      onMouseDown: function onMouseDown(e) {
        return e.preventDefault();
      },
      onMouseUp: function onMouseUp(e) {
        return e.preventDefault();
      },
      onMouseEnter: function onMouseEnter(e) {
        if (open === index) {
          mouseEvents.onMouseUp(e);
          e.button = 1;
          mouseEvents.onMouseUp(e);
        }
      }
    }, /*#__PURE__*/React.createElement(PreventScrollToParents, {
      key: "brushTags"
    }, /*#__PURE__*/React.createElement(Paper, {
      className: classnames(classes.regionInfo),
      style: _objectSpread({
        opacity: open === index && 1,
        zIndex: open === index ? 20 : 15,
        position: "absolute",
        cursor: "pointer",
        border: lines[index].invalid && "1px solid red" || !isTL && lines[index].update_user && "1px solid green",
        padding: 0
      }, popUpPos({
        index: index,
        top: item.points[1] * scale
      }) ? {
        bottom: 0
      } : {
        top: 0
      })
    }, open === index ? /*#__PURE__*/React.createElement("div", {
      style: {
        width: 200,
        padding: 10
      }
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        display: "flex",
        flexDirection: "row",
        alignItems: "flex-end"
      }
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        display: "flex",
        backgroundColor: colors[(lazyBrushClassification === null || lazyBrushClassification === void 0 ? void 0 : lazyBrushClassification.findIndex(function (dropdown) {
          var _item$popUp, _item$popUp$classific;
          return dropdown.value === (item === null || item === void 0 ? void 0 : (_item$popUp = item.popUp) === null || _item$popUp === void 0 ? void 0 : (_item$popUp$classific = _item$popUp.classification) === null || _item$popUp$classific === void 0 ? void 0 : _item$popUp$classific.value);
        })) % colors.length] || "red",
        color: "#fff",
        padding: 4,
        paddingLeft: 8,
        paddingRight: 8,
        borderRadius: 4,
        fontWeight: "bold",
        textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
      }
    }, "Brush"), /*#__PURE__*/React.createElement("div", {
      style: {
        flexGrow: 1
      }
    }), /*#__PURE__*/React.createElement(IconButton, {
      onClick: function onClick(e) {
        var linessave = _toConsumableArray(lines);
        var filter_arr = linessave.filter(function (filters) {
          return filters.id !== item.id && filters;
        });
        setLines(filter_arr);
        var arr = _toConsumableArray(delete_annotation);
        var delete_arr = linessave.filter(function (filter) {
          if (filter.id === item.id) {
            return filter;
          }
        }).filter(Boolean);
        arr.push(delete_arr);
        window.undoArray = [].concat(_toConsumableArray(window.undoArray), ["delete~".concat(item.id)]);
        /** create DeleteBrush Arr */
        window.deleteBrush = [].concat(_toConsumableArray(window.deleteBrush), _toConsumableArray(arr)).flat();
        setdelete_annotation(arr);
        setOpen(-1);
      },
      tabIndex: -1,
      style: {
        width: 22,
        height: 22
      },
      size: "small",
      variant: "outlined"
    }, /*#__PURE__*/React.createElement(TrashIcon, {
      style: {
        width: 16,
        height: 16
      }
    })), invalid_show && /*#__PURE__*/React.createElement(IconButton, {
      onClick: function onClick() {
        var linessave = _toConsumableArray(lines);
        var find_same_id = linessave === null || linessave === void 0 ? void 0 : linessave.map(function (items, itemIndex) {
          if (items.id === item.id) {
            lines[itemIndex].invalid = lines[itemIndex].invalid ? false : true;
            lines[itemIndex].invalid_tag = lines[itemIndex].invalid ? lines[index].popUp.tags : [];
          }
          return linessave;
        });
        setLines(linessave);
      },
      tabIndex: -1,
      style: {
        width: 22,
        height: 22
      },
      size: "small",
      variant: "outlined"
    }, /*#__PURE__*/React.createElement(WarningAmberIcon, {
      style: {
        color: lines[index].invalid ? "#faad14" : "grey",
        width: 16,
        height: 16
      }
    }))), /*#__PURE__*/React.createElement("div", {
      style: {
        marginTop: 6
      }
    }, /*#__PURE__*/React.createElement(TaskFormLabel, {
      display_label: regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.display_label,
      isAstrick: false,
      isRequired: regionClsMandatory,
      className: "region_font"
    }), /*#__PURE__*/React.createElement(CreatableSelect, {
      menuPosition: "fixed",
      menuPlacement: "auto",
      placeholder: (regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.display_label) || "Classification",
      onChange: function onChange(o, actionMeta) {
        handleChangeClassification(actionMeta, item, o);
      },
      value: lines[index].popUp.classification,
      options: classification_brush
    }), /*#__PURE__*/React.createElement(ErrorMessage, {
      mandatory: regionClsMandatory,
      content: ((_lines$index$popUp$cl = lines[index].popUp.classification) === null || _lines$index$popUp$cl === void 0 ? void 0 : _lines$index$popUp$cl.value) !== undefined ? String((_lines$index$popUp$cl2 = lines[index].popUp.classification) === null || _lines$index$popUp$cl2 === void 0 ? void 0 : _lines$index$popUp$cl2.value) : "",
      validate: brushValidate,
      error_label: regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.display_label
    })), (lazyBrushTags === null || lazyBrushTags === void 0 ? void 0 : lazyBrushTags.length) ? /*#__PURE__*/React.createElement("div", {
      style: {
        marginTop: 4
      }
    }, /*#__PURE__*/React.createElement(TaskFormLabel, {
      display_label: regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.display_label,
      isAstrick: false,
      isRequired: regionTagsMandatory,
      className: "region_font"
    }), /*#__PURE__*/React.createElement(CreatableSelect, {
      component: null,
      menuPosition: "fixed",
      menuPlacement: "auto",
      value: lines[index].popUp.tags,
      styles: customStyles,
      placeholder: (regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.display_label) || "Tags",
      onChange: function onChange(o, actionMeta) {
        if (actionMeta.action === "create-option") {
          var _o$find;
          var newValue = o === null || o === void 0 ? void 0 : (_o$find = o.find(function (item) {
            return item.__isNew__ === true;
          })) === null || _o$find === void 0 ? void 0 : _o$find.value;
          onRegionTagAdded(newValue);
        }
        setLines(function (prevLines) {
          return prevLines.map(function (line, itemIndex) {
            if (line.id === item.id) {
              line.popUp.tags = o;
              line.tag_count = (o === null || o === void 0 ? void 0 : o.length) || 0;
              if (o === null || o === void 0 ? void 0 : o.length) {
                var _line$invalid_tag, _line$invalid_tag2, _line$invalid_tag3, _line$invalid_tag4;
                var qc_invalid = tag_qual_check(o, itemIndex);
                if (qc_invalid && !invalid_show && ((_line$invalid_tag = line.invalid_tag) === null || _line$invalid_tag === void 0 ? void 0 : _line$invalid_tag.length)) {
                  line.update_user = false;
                  line.invalid = true;
                } else if (!qc_invalid && !invalid_show && ((_line$invalid_tag2 = line.invalid_tag) === null || _line$invalid_tag2 === void 0 ? void 0 : _line$invalid_tag2.length)) {
                  line.update_user = true;
                  line.invalid = false;
                } else if (((_line$invalid_tag3 = line.invalid_tag) === null || _line$invalid_tag3 === void 0 ? void 0 : _line$invalid_tag3.length) && invalid_show) {
                  line.update_user = false;
                  line.invalid = false;
                  line.invalid_tag = [];
                } else if (!((_line$invalid_tag4 = line.invalid_tag) === null || _line$invalid_tag4 === void 0 ? void 0 : _line$invalid_tag4.length)) {
                  line.update_user = false;
                  line.invalid = false;
                  line.invalid_tag = [];
                }
              }
            }
            return line;
          });
        });
        setTegged(true);
        setLoacal_id(getRandomId());
      },
      isMulti: true,
      options: tag_brush
    }), /*#__PURE__*/React.createElement(ErrorMessage, {
      mandatory: regionTagsMandatory,
      content: lines[index].popUp.tags,
      validate: brushValidate,
      error_label: regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.display_label
    })) : null, !invalid_show && ((_lines$index2 = lines[index]) === null || _lines$index2 === void 0 ? void 0 : (_lines$index2$invalid = _lines$index2.invalid_tag) === null || _lines$index2$invalid === void 0 ? void 0 : _lines$index2$invalid.length) && tag_qual_check(lines[index].popUp.tags, index) && (lazyBrushTags === null || lazyBrushTags === void 0 ? void 0 : lazyBrushTags.length) ? /*#__PURE__*/React.createElement("span", null, "Enter correct data, this is marked invalid") : null, /*#__PURE__*/React.createElement("div", {
      style: {
        marginTop: 4,
        display: "flex",
        justifyContent: "flex-end"
      }
    }, /*#__PURE__*/React.createElement(Button, {
      style: {
        height: "30px",
        background: "#005f86",
        minWidth: "45px"
      },
      size: "small",
      onClick: function onClick(event) {
        var _lines$index$popUp$cl3, _lines$index$popUp$cl4, _lines$index$popUp$ta;
        if (regionClsMandatory && ((_lines$index$popUp$cl3 = lines[index].popUp.classification) === null || _lines$index$popUp$cl3 === void 0 ? void 0 : _lines$index$popUp$cl3.value) === undefined || regionClsMandatory && !String((_lines$index$popUp$cl4 = lines[index].popUp.classification) === null || _lines$index$popUp$cl4 === void 0 ? void 0 : _lines$index$popUp$cl4.value)) {
          setBrushValidate(true);
          return;
        }
        if (regionTagsMandatory && !((_lines$index$popUp$ta = lines[index].popUp.tags) === null || _lines$index$popUp$ta === void 0 ? void 0 : _lines$index$popUp$ta.length)) {
          setBrushValidate(true);
          return;
        }
        setBrushValidate(false);
        if (!lines.isLocked) {
          setOpen(-1);
          setbrushHighlight(-1);
        }
        event.preventDefault();
      },
      variant: "contained",
      color: "primary"
    }, /*#__PURE__*/React.createElement(CheckIcon, {
      style: {
        width: 16,
        height: 16
      }
    })))) : !item.isHide && /*#__PURE__*/React.createElement("div", {
      style: {
        padding: !item.isLocked && 8
      },
      onClick: function onClick() {
        if (!lines.isLocked) {
          if (!isReadingMode) {
            !item.isLocked && setOpen(index);
            !item.isLocked && setbrushHighlight(index);
          }
        }
      }
    }, item.isLocked ? /*#__PURE__*/React.createElement(Paper, {
      style: {
        position: "absolute",
        left: 0,
        zIndex: 10,
        backgroundColor: "#fff",
        borderRadius: 4,
        padding: 2,
        paddingBottom: 0,
        opacity: 0.5,
        pointerEvents: "none"
      }
    }, /*#__PURE__*/React.createElement(LockIcon, {
      fontSize: "small",
      style: {
        width: 16,
        height: 16,
        color: "#333",
        cursor: "default"
      }
    })) : /*#__PURE__*/React.createElement(React.Fragment, null, (item === null || item === void 0 ? void 0 : (_item$popUp2 = item.popUp) === null || _item$popUp2 === void 0 ? void 0 : (_item$popUp2$classifi = _item$popUp2.classification) === null || _item$popUp2$classifi === void 0 ? void 0 : _item$popUp2$classifi.label) && /*#__PURE__*/React.createElement("div", {
      className: "name",
      style: {
        display: "flex",
        justifyContent: "flex-start",
        alignItems: "center",
        width: "max-content"
      }
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: item === null || item === void 0 ? void 0 : (_item$color = item.color) === null || _item$color === void 0 ? void 0 : _item$color.replace("0.5", "1"),
        width: "10px",
        height: "10px",
        boxShadow: "0px 0px 2px rgb(0 0 0 / 40%)",
        marginRight: "4px",
        borderRadius: "5px"
      }
    }), /*#__PURE__*/React.createElement("span", null, item === null || item === void 0 ? void 0 : (_item$popUp3 = item.popUp) === null || _item$popUp3 === void 0 ? void 0 : _item$popUp3.classification.label)), /*#__PURE__*/React.createElement("div", {
      className: "tags"
    }, (_asMutable = asMutable((item === null || item === void 0 ? void 0 : (_item$popUp4 = item.popUp) === null || _item$popUp4 === void 0 ? void 0 : _item$popUp4.tags) || [])) === null || _asMutable === void 0 ? void 0 : _asMutable.map(function (t) {
      return /*#__PURE__*/React.createElement("div", {
        key: t.label,
        className: "tag"
      }, t.label);
    })))))));
  }))));
}
export default BrushPopup;